# -*- coding: utf-8 -*-


import zipfile
import shutil
import os
import sys
import tempfile

def remove_from_zip(zipfname, *filenames):
    tempdir = tempfile.mkdtemp()
    try:
        tempname = os.path.join(tempdir, 'new.zip')
        with zipfile.ZipFile(zipfname, 'r') as zipread:
            with zipfile.ZipFile(tempname, 'w') as zipwrite:
                for item in zipread.infolist():
                    if item.filename not in filenames:
                        data = zipread.read(item.filename)
                        zipwrite.writestr(item, data)
        shutil.move(tempname, zipfname)
    finally:
        shutil.rmtree(tempdir)


if __name__ == '__main__':
    ods_name = sys.argv[1] if len(sys.argv) > 1 else 'ltweb_demo_20221120.ods'
    py_name = sys.argv[2] if len(sys.argv) > 2 else 'ltweb_request.py'
    print("Delete and create directory with_macro")
    shutil.rmtree("with_macro", True)
    os.mkdir("with_macro")

    filename = os.path.join("with_macro", ods_name)
    print("Open file " + ods_name)
    shutil.copyfile(ods_name, filename)
    
    remove_from_zip(filename, "Scripts/python/" + py_name)
    doc = zipfile.ZipFile(filename, 'a')
    doc.write(py_name, "Scripts/python/" + py_name)
    
    manifest = []
    for line in doc.open('META-INF/manifest.xml'):
        if '</manifest:manifest>' in line.decode('utf-8'):
            for path in ['Scripts/','Scripts/python/', 'Scripts/python/' + py_name]:
                line_w = ' <manifest:file-entry manifest:media-type="application/binary" manifest:full-path="%s"/>' % path
                if line_w not in manifest:
                    manifest.append(line_w)
        manifest.append(line.decode('utf-8'))
    doc.close()

    remove_from_zip(filename, 'META-INF/manifest.xml')

    doc = zipfile.ZipFile(filename, 'a')
    doc.writestr('META-INF/manifest.xml', ''.join(manifest))
    doc.close()
    print("File created: "+filename)